import 'dart:async';

import 'package:aliyun_oss_platform_interface/aliyun_oss_platform_interface.dart';

Future<String?> saveFileToDownload(String fileName, String mimeType) {
  return AliyunOSSPlatform.instance.saveFileToDownload(fileName, mimeType);
}

Future<String> getMd5Str(String filePath) {
  return AliyunOSSPlatform.instance.getMd5Str(filePath);
}

Future<dynamic> init(String endpoint, OSSCredentialProvider provider) {
  return AliyunOSSPlatform.instance.init(endpoint, provider);
}

Future<dynamic> upload(String bucketName) {
  return AliyunOSSPlatform.instance.upload(bucketName);
}

Future<dynamic> uploadWithPath(String bucketName, String filePath, String md5) {
  return AliyunOSSPlatform.instance.uploadWithPath(bucketName, filePath, md5);
}

Future<String?> pauseUpload(String objectKey) {
  return AliyunOSSPlatform.instance.pauseUpload(objectKey);
}

Future<String?> resumeUpload(String objectKey) {
  return AliyunOSSPlatform.instance.resumeUpload(objectKey);
}

Future<dynamic> download(
    String? bucketName, String md5, String fileName, String mimeType) {
  return AliyunOSSPlatform.instance
      .download(bucketName, md5, fileName, mimeType);
}

Future<String?> pauseDownload(String objectKey) {
  return AliyunOSSPlatform.instance.pauseDownload(objectKey);
}

Future<String?> resumeDownload(String objectKey) {
  return AliyunOSSPlatform.instance.resumeDownload(objectKey);
}

void addUploadMethodCallListener(UploadMethodCallListener listener) {
  return AliyunOSSPlatform.instance.addUploadMethodCallListener(listener);
}

void removeUploadMethodCallListener(UploadMethodCallListener listener) {
  return AliyunOSSPlatform.instance.removeUploadMethodCallListener(listener);
}

void addDownloadMethodCallListener(DownloadMethodCallListener listener) {
  return AliyunOSSPlatform.instance.addDownloadMethodCallListener(listener);
}

void removeDownloadMethodCallListener(DownloadMethodCallListener listener) {
  return AliyunOSSPlatform.instance.removeDownloadMethodCallListener(listener);
}
